import typescriptDeferred = require("typescript-deferred");
import interfaces = require("./interfaces");
export interface IQueryEqualPair {
    key: string;
    value: string;
}
export interface IQueryObject {
    limit?: number;
    offset?: number;
    equals?: IQueryEqualPair[];
}
export declare class USMART {
    private authInfo;
    private client;
    constructor(auth?: interfaces.IAuthInfo);
    request(organisation: string, resource: string, revision?: string, query?: IQueryObject): typescriptDeferred.PromiseInterface<{}>;
    subscribe(organisation: string, dataset: string, onMessage: () => void): void;
    private setupClient(callback);
    private buildEqualQueries(equals);
    private buildQuery(query?);
    private buildURL(organisation, resource, revision);
}
