"use strict";
exports.__esModule = true;
var Primus = require("Primus");
var deferredTS = require("typescript-deferred");
var USMARTClient = (function () {
    function USMARTClient(serviceName, auth, debug) {
        if (debug === void 0) { debug = false; }
        var _this = this;
        this.messageCount = 0;
        this.messagePromise = {};
        this.authInfo = auth;
        this.socket = Primus.createSocket({
            transformer: "engine.io"
        });
        this.client = new this.socket(this.getURL(serviceName, debug), {
            transport: {
                extraHeaders: {
                    "api-key-id": auth.keyId,
                    "api-key-secret": auth.keySecret
                }
            }
        });
        this.client.on("data", function (data) {
            if (typeof data.messageCount !== "undefined" && _this.messagePromise.hasOwnProperty(data.messageCount)) {
                _this.messagePromise[data.messageCount].resolve(data);
            }
        });
    }
    USMARTClient.prototype.actionWithParams = function (action, params) {
        var currentMessageCount = this.messageCount++;
        var deferred = deferredTS.create();
        params.action = action;
        this.client.write({
            event: "action",
            params: params
        });
        this.messagePromise[currentMessageCount] = deferred;
        return deferred.promise;
    };
    USMARTClient.prototype.getURL = function (serviceName, debug) {
        return "not-set";
    };
    return USMARTClient;
}());
exports.USMARTClient = USMARTClient;
